function compile_cbs

% This file is part of CBS.
%
% CBS is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% CBS is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with CBS.  If not, see <http://www.gnu.org/licenses/>.

debug = 0;
nthreads = 4;
cpp_flags = '/openmp /O2 /favor:EM64T';
mex_opts = '-largeArrayDims';

delete *.obj
delete *.mex*
delete *.pdb
delete *.ilk

files = {'cbs.cpp', 'cbs_mex.cpp', 'cbs_normalize.cpp', 'cbs_eval.cpp', 'cbs_coloc.cpp', 'cbs_coloc_deriv.cpp'};

if debug == 1
    mex_opts = [mex_opts ' -g'];
end

for ii = 1:numel(files)
    fprintf('Compiling "%s"\n', files{ii});
    eval(sprintf('mex -g -c %s COMPFLAGS="$COMPFLAGS %s -DNTHREADS=%d" %s', mex_opts, cpp_flags, nthreads, files{ii}))
end

mex cbs_normalize.obj cbs.obj cbs_mex.obj
mex cbs_eval.obj cbs.obj cbs_mex.obj
mex cbs_coloc.obj cbs.obj cbs_mex.obj
mex cbs_coloc_deriv.obj cbs.obj cbs_mex.obj

delete *.obj
